gnu.trove

## Class TIntObjectHashMap<V>

- java.lang.Object
- - gnu.trove.THash
  - - gnu.trove.TPrimitiveHash
    - - gnu.trove.TIntHash
      - - gnu.trove.TIntObjectHashMap<V>

All Implemented Interfaces:
  TIntHashingStrategy, java.io.Externalizable, java.io.Serializable, java.lang.Cloneable

    public class TIntObjectHashMap<V>
    extends TIntHash
    implements java.io.Externalizable

An open addressed Map implementation for int keys and Object values. Created: Sun Nov 4 08:52:45 2001

Author:
  Eric D. Friedman
See Also:
  Serialized Form

### Field Summary

Fields
`protected V[]` `_values` the values of the map

### Fields inherited from class gnu.trove.TIntHash

`_hashingStrategy, _set`

### Fields inherited from class gnu.trove.TPrimitiveHash

`_states, FREE, FULL, REMOVED`

### Fields inherited from class gnu.trove.THash

`_autoCompactionFactor, _autoCompactRemovesRemaining, _free, _loadFactor, _maxSize, _size, DEFAULT_INITIAL_CAPACITY, DEFAULT_LOAD_FACTOR`

### Constructor Summary

Constructors
Constructor and Description
`TIntObjectHashMap()` Creates a new `TIntObjectHashMap` instance with the default capacity and load factor.
`TIntObjectHashMap(int initialCapacity)` Creates a new `TIntObjectHashMap` instance with a prime capacity equal to or greater than `initialCapacity` and with the default load factor.
`TIntObjectHashMap(int initialCapacity, float loadFactor)` Creates a new `TIntObjectHashMap` instance with a prime capacity equal to or greater than `initialCapacity` and with the specified load factor.
`TIntObjectHashMap(int initialCapacity, float loadFactor, TIntHashingStrategy strategy)` Creates a new `TIntObjectHashMap` instance with a prime value at or near the specified capacity and load factor.
`TIntObjectHashMap(int initialCapacity, TIntHashingStrategy strategy)` Creates a new `TIntObjectHashMap` instance whose capacity is the next highest prime above `initialCapacity + 1` unless that value is already prime.
`TIntObjectHashMap(TIntHashingStrategy strategy)` Creates a new `TIntObjectHashMap` instance with the default capacity and load factor.

### Method Summary

Methods
`void` `clear()` Empties the map.
`TIntObjectHashMap<V>` `clone()`
`boolean` `containsKey(int key)` checks for the present of `key` in the keys of the map.
`boolean` `containsValue(V val)` checks for the presence of `val` in the values of the map.
`boolean` `equals(java.lang.Object other)` Compares this map with another map for equality of their stored entries.
`boolean` `forEachEntry(TIntObjectProcedure<V> procedure)` Executes `procedure` for each key/value entry in the map.
`boolean` `forEachKey(TIntProcedure procedure)` Executes `procedure` for each key in the map.
`boolean` `forEachValue(TObjectProcedure<V> procedure)` Executes `procedure` for each value in the map.
`V` `get(int key)` retrieves the value for `key`
`java.lang.Object[]` `getValues()` Returns the values of the map.
`<T> T[]` `getValues(T[] a)` Return the values of the map; the runtime type of the returned array is that of the specified array.
`int` `hashCode()`
`TIntObjectIterator<V>` `iterator()`
`int[]` `keys()` returns the keys of the map.
`int[]` `keys(int[] a)` returns the keys of the map.
`V` `put(int key, V value)` Inserts a key/value pair into the map.
`void` `putAll(TIntObjectHashMap<V> map)` Put all the entries from the given map into this map.
`V` `putIfAbsent(int key, V value)` Inserts a key/value pair into the map if the specified key is not already associated with a value.
`void` `readExternal(java.io.ObjectInput in)`
`protected void` `rehash(int newCapacity)` rehashes the map to the new capacity.
`V` `remove(int key)` Deletes a key/value pair from the map.
`protected void` `removeAt(int index)` removes the mapping at `index` from the map.
`boolean` `retainEntries(TIntObjectProcedure<V> procedure)` Retains only those entries in the map for which the procedure returns a true value.
`protected int` `setUp(int initialCapacity)` initializes the hashtable to a prime capacity which is at least `initialCapacity + 1`.
`java.lang.String` `toString()`
`void` `transformValues(TObjectFunction<V,V> function)` Transform the values in this map using `function`.
`void` `writeExternal(java.io.ObjectOutput out)`

### Methods inherited from class gnu.trove.TIntHash

`computeHashCode, contains, forEach, index, insertionIndex`

### Methods inherited from class gnu.trove.TPrimitiveHash

`capacity`

### Methods inherited from class gnu.trove.THash

`calculateGrownCapacity, compact, ensureCapacity, getAutoCompactionFactor, isEmpty, postInsertHook, reenableAutoCompaction, setAutoCompactionFactor, size, tempDisableAutoCompaction, trimToSize`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### _values

    protected transient V[] _values

the values of the map

### Constructor Detail

#### TIntObjectHashMap

    public TIntObjectHashMap()

Creates a new `TIntObjectHashMap` instance with the default capacity and load factor.

#### TIntObjectHashMap

    public TIntObjectHashMap(int initialCapacity)

Creates a new `TIntObjectHashMap` instance with a prime capacity equal to or greater than `initialCapacity` and with the default load factor.

Parameters:
  `initialCapacity` - an `int` value

#### TIntObjectHashMap

    public TIntObjectHashMap(int initialCapacity,
                     float loadFactor)

Creates a new `TIntObjectHashMap` instance with a prime capacity equal to or greater than `initialCapacity` and with the specified load factor.

Parameters:
  `initialCapacity` - an `int` value
  `loadFactor` - a `float` value

#### TIntObjectHashMap

    public TIntObjectHashMap(TIntHashingStrategy strategy)

Creates a new `TIntObjectHashMap` instance with the default capacity and load factor.

Parameters:
  `strategy` - used to compute hash codes and to compare keys.

#### TIntObjectHashMap

    public TIntObjectHashMap(int initialCapacity,
                     TIntHashingStrategy strategy)

Creates a new `TIntObjectHashMap` instance whose capacity is the next highest prime above `initialCapacity + 1` unless that value is already prime.

Parameters:
  `initialCapacity` - an `int` value
  `strategy` - used to compute hash codes and to compare keys.

#### TIntObjectHashMap

    public TIntObjectHashMap(int initialCapacity,
                     float loadFactor,
                     TIntHashingStrategy strategy)

Creates a new `TIntObjectHashMap` instance with a prime value at or near the specified capacity and load factor.

Parameters:
  `initialCapacity` - used to find a prime capacity for the table.
  `loadFactor` - used to calculate the threshold over which rehashing takes place.
  `strategy` - used to compute hash codes and to compare keys.

### Method Detail

#### clone

    public TIntObjectHashMap<V> clone()

Overrides:
  `clone` in class `TIntHash`
Returns:
  a deep clone of this collection

#### iterator

    public TIntObjectIterator<V> iterator()

Returns:
  a TIntObjectIterator with access to this map's keys and values

#### setUp

    protected int setUp(int initialCapacity)

initializes the hashtable to a prime capacity which is at least `initialCapacity + 1`.

Overrides:
  `setUp` in class `TIntHash`
Parameters:
  `initialCapacity` - an `int` value
Returns:
  the actual capacity chosen

#### put

    public V put(int key,
        V value)

Inserts a key/value pair into the map.

Parameters:
  `key` - an `int` value
  `value` - an `Object` value
Returns:
  the previous value associated with `key`, or `null` if none was found.

#### putIfAbsent

    public V putIfAbsent(int key,
                V value)

Inserts a key/value pair into the map if the specified key is not already associated with a value.

Parameters:
  `key` - an `int` value
  `value` - an `Object` value
Returns:
  the previous value associated with `key`, or `null` if none was found.

#### putAll

    public void putAll(TIntObjectHashMap<V> map)

Put all the entries from the given map into this map.

Parameters:
  `map` - The map from which entries will be obtained to put into this map.

#### rehash

    protected void rehash(int newCapacity)

rehashes the map to the new capacity.

Specified by:
  `rehash` in class `THash`
Parameters:
  `newCapacity` - an `int` value

#### get

    public V get(int key)

retrieves the value for `key`

Parameters:
  `key` - an `int` value
Returns:
  the value of `key` or (int)0 if no such mapping exists.

#### clear

    public void clear()

Empties the map.

Overrides:
  `clear` in class `THash`

#### remove

    public V remove(int key)

Deletes a key/value pair from the map.

Parameters:
  `key` - an `int` value
Returns:
  an `Object` value or (int)0 if no such mapping exists.

#### equals

    public boolean equals(java.lang.Object other)

Compares this map with another map for equality of their stored entries.

Overrides:
  `equals` in class `java.lang.Object`
Parameters:
  `other` - an `Object` value
Returns:
  a `boolean` value

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `java.lang.Object`

#### removeAt

    protected void removeAt(int index)

removes the mapping at `index` from the map.

Overrides:
  `removeAt` in class `TIntHash`
Parameters:
  `index` - an `int` value

#### getValues

    public java.lang.Object[] getValues()

Returns the values of the map.

Returns:
  a `Collection` value
See Also:
  `getValues(Object[])`

#### getValues

    public <T> T[] getValues(T[] a)

Return the values of the map; the runtime type of the returned array is that of the specified array.

Parameters:
  `a` - the array into which the elements of this collection are to be stored, if it is big enough; otherwise, a new array of the same runtime type is allocated for this purpose.
Returns:
  an array containing the elements of this collection
Throws:
  `java.lang.ArrayStoreException` - the runtime type of the specified array is not a supertype of the runtime type of every element in this collection.
  `java.lang.NullPointerException` - if the specified array is `null`.
See Also:
  `getValues()`

#### keys

    public int[] keys()

returns the keys of the map.

Returns:
  a `Set` value

#### keys

    public int[] keys(int[] a)

returns the keys of the map.

Parameters:
  `a` - the array into which the elements of the list are to be stored, if it is big enough; otherwise, a new array of the same type is allocated for this purpose.
Returns:
  a `Set` value

#### containsValue

    public boolean containsValue(V val)

checks for the presence of `val` in the values of the map.

Parameters:
  `val` - an `Object` value
Returns:
  a `boolean` value

#### containsKey

    public boolean containsKey(int key)

checks for the present of `key` in the keys of the map.

Parameters:
  `key` - an `int` value
Returns:
  a `boolean` value

#### forEachKey

    public boolean forEachKey(TIntProcedure procedure)

Executes `procedure` for each key in the map.

Parameters:
  `procedure` - a `TIntProcedure` value
Returns:
  false if the loop over the keys terminated because the procedure returned false for some key.

#### forEachValue

    public boolean forEachValue(TObjectProcedure<V> procedure)

Executes `procedure` for each value in the map.

Parameters:
  `procedure` - a `TObjectProcedure` value
Returns:
  false if the loop over the values terminated because the procedure returned false for some value.

#### forEachEntry

    public boolean forEachEntry(TIntObjectProcedure<V> procedure)

Executes `procedure` for each key/value entry in the map.

Parameters:
  `procedure` - a `TOIntObjectProcedure` value
Returns:
  false if the loop over the entries terminated because the procedure returned false for some entry.

#### retainEntries

    public boolean retainEntries(TIntObjectProcedure<V> procedure)

Retains only those entries in the map for which the procedure returns a true value.

Parameters:
  `procedure` - determines which entries to keep
Returns:
  true if the map was modified.

#### transformValues

    public void transformValues(TObjectFunction<V,V> function)

Transform the values in this map using `function`.

Parameters:
  `function` - a `TObjectFunction` value

#### writeExternal

    public void writeExternal(java.io.ObjectOutput out)
                       throws java.io.IOException

Specified by:
  `writeExternal` in interface `java.io.Externalizable`
Overrides:
  `writeExternal` in class `THash`
Throws:
  `java.io.IOException`

#### readExternal

    public void readExternal(java.io.ObjectInput in)
                      throws java.io.IOException,
                             java.lang.ClassNotFoundException

Specified by:
  `readExternal` in interface `java.io.Externalizable`
Overrides:
  `readExternal` in class `THash`
Throws:
  `java.io.IOException`
  `java.lang.ClassNotFoundException`

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`